export class ParserService {
    parseVideo(data) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
        if (!(data === null || data === void 0 ? void 0 : data.videoRenderer)) {
            return undefined;
        }
        try {
            const vr = data.videoRenderer;
            // Titel extrahieren und evtl. Backslashes fixen
            let title = (_d = (_c = (_b = (_a = vr.title) === null || _a === void 0 ? void 0 : _a.runs) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.text) !== null && _d !== void 0 ? _d : '';
            title = this.cleanUpName(title);
            // Optional: decodeURIComponent nur, wenn es sinnvoll ist (hier z.B. keine Fehler werfen)
            try {
                title = decodeURIComponent(title);
            }
            catch (_u) {
                // ignore decode errors
            }
            // Thumbnail: letztes Thumbnail-Objekt nutzen (meist größte Auflösung)
            const thumbnails = (_f = (_e = vr.thumbnail) === null || _e === void 0 ? void 0 : _e.thumbnails) !== null && _f !== void 0 ? _f : [];
            const thumbnail = thumbnails.length ? thumbnails[thumbnails.length - 1] : null;
            // Views aus Text extrahieren und in Zahl konvertieren
            const viewsText = (_h = (_g = vr.viewCountText) === null || _g === void 0 ? void 0 : _g.simpleText) !== null && _h !== void 0 ? _h : '';
            const views = Number(viewsText.replace(/\D/g, '')) || 0;
            return {
                id: {
                    videoId: vr.videoId
                },
                url: `https://www.youtube.com/watch?v=${vr.videoId}`,
                // tslint:disable-next-line:object-literal-sort-keys
                title,
                description: (_m = (_l = (_k = (_j = vr.descriptionSnippet) === null || _j === void 0 ? void 0 : _j.runs) === null || _k === void 0 ? void 0 : _k[0]) === null || _l === void 0 ? void 0 : _l.text) !== null && _m !== void 0 ? _m : '',
                duration_raw: (_p = (_o = vr.lengthText) === null || _o === void 0 ? void 0 : _o.simpleText) !== null && _p !== void 0 ? _p : null,
                snippet: {
                    url: `https://www.youtube.com/watch?v=${vr.videoId}`,
                    // tslint:disable-next-line:object-literal-sort-keys
                    duration: (_r = (_q = vr.lengthText) === null || _q === void 0 ? void 0 : _q.simpleText) !== null && _r !== void 0 ? _r : null,
                    publishedAt: (_t = (_s = vr.publishedTimeText) === null || _s === void 0 ? void 0 : _s.simpleText) !== null && _t !== void 0 ? _t : null,
                    thumbnails: thumbnail
                        ? {
                            id: vr.videoId,
                            url: thumbnail.url,
                            // tslint:disable-next-line:object-literal-sort-keys
                            default: thumbnail,
                            high: thumbnail,
                            height: thumbnail.height,
                            width: thumbnail.width
                        }
                        : null,
                    title
                },
                views
            };
        }
        catch (_v) {
            return undefined;
        }
    }
    cleanUpName(name) {
        return name
            // Unicode-Escape-Sequenzen wie \uXXXX in Zeichen umwandeln
            .replace(/\\u[\dA-Fa-f]{4}/g, (match) => String.fromCharCode(parseInt(match.slice(2), 16)))
            .replace(/&amp;/gi, '&')
            .replace(/&quot;/gi, '"')
            .replace(/&lt;/gi, '<')
            .replace(/&gt;/gi, '>')
            .replace(/&apos;/gi, "'")
            .replace(/[^\p{L}\p{N}\s\-_.,!?'":;%&()]/gu, '')
            .replace(/\s+/g, ' ')
            .trim();
    }
}
